import { ScalarsMap } from './types';
import { DeclarationBlockConfig } from './utils';
export interface ParsedConfig {
    scalars: ScalarsMap;
    convert: (str: string) => string;
    typesPrefix: string;
}
export interface RawConfig {
    scalars?: ScalarsMap;
    namingConvention?: string;
    typesPrefix?: string;
}
export declare class BaseVisitor<TRawConfig extends RawConfig = RawConfig, TPluginConfig extends ParsedConfig = ParsedConfig> {
    protected _parsedConfig: TPluginConfig;
    protected _declarationBlockConfig: DeclarationBlockConfig;
    constructor(rawConfig: TRawConfig, additionalConfig: TPluginConfig, defaultScalars?: ScalarsMap);
    readonly config: TPluginConfig;
    readonly scalars: ScalarsMap;
    convertName(name: any, addPrefix?: boolean): string;
}
