"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var graphql_codegen_plugin_helpers_1 = require("graphql-codegen-plugin-helpers");
var autoBind = require("auto-bind");
var scalars_1 = require("./scalars");
var BaseVisitor = /** @class */ (function () {
    function BaseVisitor(rawConfig, additionalConfig, defaultScalars) {
        if (defaultScalars === void 0) { defaultScalars = scalars_1.DEFAULT_SCALARS; }
        this._declarationBlockConfig = {};
        this._parsedConfig = __assign({ scalars: __assign({}, (defaultScalars || scalars_1.DEFAULT_SCALARS), (rawConfig.scalars || {})), convert: rawConfig.namingConvention ? graphql_codegen_plugin_helpers_1.resolveExternalModuleAndFn(rawConfig.namingConvention) : utils_1.toPascalCase, typesPrefix: rawConfig.typesPrefix || '' }, (additionalConfig || {}));
        autoBind(this);
    }
    Object.defineProperty(BaseVisitor.prototype, "config", {
        get: function () {
            return this._parsedConfig;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseVisitor.prototype, "scalars", {
        get: function () {
            return this.config.scalars;
        },
        enumerable: true,
        configurable: true
    });
    BaseVisitor.prototype.convertName = function (name, addPrefix) {
        if (addPrefix === void 0) { addPrefix = true; }
        return (addPrefix ? this.config.typesPrefix : '') + this.config.convert(name);
    };
    return BaseVisitor;
}());
exports.BaseVisitor = BaseVisitor;
//# sourceMappingURL=base-visitor.js.map